/***************************************************************
	CPUŗL e평[`(LPC2388p)
***************************************************************/

/* CPU/荞ݐ֐wb_ */
#include "cpu_init.h"


/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* NbNp[Rg[䃌WX^ */
#define CLK_PLLCON		((volatile unsigned int *)(0xE01FC080))
#define CLK_PLLCFG		((volatile unsigned int *)(0xE01FC084))
#define CLK_PLLSTAT		((volatile unsigned int *)(0xE01FC088))
#define CLK_PLLFEED		((volatile unsigned int *)(0xE01FC08C))

#define CLK_CCLKCFG		((volatile unsigned int *)(0xE01FC104))
#define CLK_USBCLKCFG	((volatile unsigned int *)(0xE01FC108))
#define CLK_CLKSRCSEL	((volatile unsigned int *)(0xE01FC10C))

#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))


/* ANZ[VW[ */
#define MAM_MAMCR		((volatile unsigned int *)(0xE01FC000))
#define MAM_MAMTIM		((volatile unsigned int *)(0xE01FC004))



/* CPUŗL */
void CPU_Initialize(void)
{
	/*** PLLNbNU ***/

	/* łPLL쒆ꍇ͒~ */
	if ( *CLK_PLLSTAT & (1<<25) ) {
		/* PLLCON - PLL Enable & disconnected */
		*CLK_PLLCON   =0x00000001;
		/* PLL Feed operation */
		*CLK_PLLFEED  =0x000000AA;
		*CLK_PLLFEED  =0x00000055;
	}
	/* PLLCON - PLL Disable & disconnected(PLLS~) */
	*CLK_PLLCON   =0x00000000;
	/* PLL Feed operation */
	*CLK_PLLFEED  =0x000000AA;
	*CLK_PLLFEED  =0x00000055;

	*SYS_SCS = 0x21;	/* 12MHz OSC Enable & FGPIO Select */
	while((*SYS_SCS&0x40) == 0){}	/* OSCSTAT Wait */

	/* CLKSRCSEL - MASTER oscillator select */
	*CLK_CLKSRCSEL=0x00000001;

	/* PLLCFG - MCLK=12MHz use, FCC0 = 288MHz M=144,N=12 */
	*CLK_PLLCFG   =0x000B008F;
	/* PLL Feed operation. */
	*CLK_PLLFEED  =0x000000AA;
	*CLK_PLLFEED  =0x00000055;

	/* PLLCON - PLL Enable & disconnected */
	*CLK_PLLCON   =0x00000001;
	/* PLL Feed operation */
	*CLK_PLLFEED  =0x000000AA;
	*CLK_PLLFEED  =0x00000055;

	/* CPU Clock Divider 1/4 */
	*CLK_CCLKCFG  =0x00000003;
	/* USB Clock Divider 1/6 */
	*CLK_USBCLKCFG=0x00000005;

	while ( ((*CLK_PLLSTAT & (1<<26)) == 0) ); /* Check lock bit status */

	/* PLLCON - PLL Enable & Connected */
	*CLK_PLLCON   =0x00000003;
	/* PLL Feed operation. */
	*CLK_PLLFEED  =0x000000AA;
	*CLK_PLLFEED  =0x00000055;
	while ( ((*CLK_PLLSTAT & (1<<25)) == 0) ); /* Check connect bit status */

	/* ANZ[VW[ݒ */
	*MAM_MAMCR  = 0;
	*MAM_MAMTIM = 3;	/* 72MHzp */
	*MAM_MAMCR  = 2;
}

//extern void CPU_IRQInterrupt(void);

/* 荞ݏ֐ 
void CPU_IRQInterrupt(void)
{
	 _~[ 
}
*/

/* CPU荞݋ */
void CPU_EnableInterrupt()
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val &= ~0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* CPU荞݋֎~ */
void CPU_DisableInterrupt()
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val |= 0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

