/***************************************************************
  CPU UART VAR\[o̓hCo(LPC2388 UART0`2p)
***************************************************************/

/* CPU UARTo̓wb_ */
#include "cpu_uart.h"

/* UARTRg[ */

#define	USE_UART_CH		0	/* UART`l0`2 */

#if (USE_UART_CH == 0)
	#define COM_BaseAdr	0xE000C000	/* UART0 x[XAhX */
#endif
#if (USE_UART_CH == 1)
	#define COM_BaseAdr	0xE0010000	/* UART1 x[XAhX */
#endif
#if (USE_UART_CH == 2)
	#define COM_BaseAdr	0xE0078000	/* UART2 x[XAhX */
#endif

#define COM_RBR			((volatile unsigned int *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned int *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned int *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned int *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned int *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned int *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned int *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned int *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned int *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned int *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned int *)(COM_BaseAdr+0x28))

/* |[gRg[ */
#define GPIO_PINSEL0	((volatile unsigned int *)(0xE002C000))
#define GPIO_PINSEL1	((volatile unsigned int *)(0xE002C004))

/* NbNp[Rg[ */
#define POW_PCONP		((volatile unsigned int *)(0xE01FC0C4))
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))


/* R\[pUART */
void CPU_UartInitialize(void)
{
#if (USE_UART_CH == 0)
	/* |[gUART[hɐݒ(UART0) */
	*GPIO_PINSEL0=(*GPIO_PINSEL0 & 0xFFFFFF0F) | 0x50;		/* TXD0&RXD0I */
	/* UART0NbN 72M/4=18MHz or 4MHz/4=1MHz */
	*CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFF3F);
	/* UART0p[Cl[u */
	*POW_PCONP = *POW_PCONP | 8;			/* UART0 */
#endif
#if (USE_UART_CH == 1)
	/* |[gUART[hɐݒ(UART1) */
	*GPIO_PINSEL0=(*GPIO_PINSEL0 & 0x3FFFFFFF) | 0x40000000;/* TXD1I */
	*GPIO_PINSEL1=(*GPIO_PINSEL1 & 0xFFFFFFFC) | 1;			/* RXD1I */
	/* UART1NbN 72M/4=18MHz or 4MHz/4=1MHz */
	*CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFCFF);
	/* UART1p[Cl[u */
	*POW_PCONP = *POW_PCONP | 0x10;			/* UART1 */
#endif
#if (USE_UART_CH == 2)
	/* |[gUART[hɐݒ(UART2) */
	*GPIO_PINSEL0=(*GPIO_PINSEL0 & 0xFF0FFFFF) | 0x500000;	/* TXD2&RXD2I */
	/* UART2NbN 72M/4=18MHz or 4MHz/4=1MHz */
	*CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFCFFFF);
	/* UART2p[Cl[u */
	*POW_PCONP = *POW_PCONP | 0x01000000;	/* UART2 */
#endif

	/* UARTݒ */
	*COM_LCR =0x80;		/* ݒ背WX^I */
	*COM_DLL =6;		/* 18MHz115200bpsݒ */
	*COM_DLM =0;
	*COM_FDR =(/*MULVAL=*/ 15 <<4)|/*DIVADDVAL=*/9;	/* FDRWX^ݒ */
	*COM_LCR =0x03;		/* peBȂ/Xgbvrbg1/f[^8rbg */
	*COM_IER =0;		/* 荞ݖgp */
}

/* R\[1o */
void CPU_UartPutch(unsigned char data)
{
	unsigned int status;
	while(1){
		status=*COM_LSR;		/* CEXe[^X擾 */
		if (status & 0x20) {	/* Mobt@󂢂Ă邩 */
			/* 1oCg(data)M */
			*COM_THR=(unsigned int)data;	/* Mf[^ */
			break;
		}
	}
}

/* R\[o(\n CR+LFo) */
void CPU_UartPuts(unsigned char *buffer)
{
	unsigned char data;
	while( (data=*(buffer++)) != 0){	/* null܂ŏo */
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[o(񒷂wt/\n CR+LFo) */
void CPU_UartPutsL(unsigned char *buffer, int len)
{
	int i;
	unsigned char data;
	for(i=0;i<len;i++){
		data=*(buffer++);
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[̓obt@`FbN */
int CPU_UartRecvCheck(void)
{
	unsigned int status;
	status=*COM_LSR;	/* CEXe[^X擾 */
	if (status & 1) {	/* f[^M */
		return 1;	/* Mf[^ */
	} else {
		return 0;	/* Mf[^Ȃ */
	}
}

/* R\[1(GR[obNȂ) */
unsigned char CPU_UartGetch(void)
{
	unsigned char data;
	while(1){
		if (CPU_UartRecvCheck()) {	/* f[^M */
			data=(unsigned char)*COM_RBR;	/* Mf[^ */
			break;
		}
	}
	return data;
}

/* R\[(CRR[h܂/ő255/GR[obN) */
int CPU_UartGets(unsigned char *buffer)
{
	unsigned char data;
	int	i;
	i=0;
	while(1){
		data=CPU_UartGetch();	/* 1 */
		*buffer=data;
		CPU_UartPutch(data);	/* 1o(GR[obN) */
		buffer++;
		i++;
		if (i>255) break;		/* ő啶ɒB */
		if (data==0x0d) break;	/* CRR[h܂ŎM */
	}
	*buffer=(char)0;			/* nullR[h */
	return i;					/* ͕ */
}

